import 'dart:async';
import 'package:flutter/material.dart';

class QudsAutoAnimatedSize extends StatefulWidget {
  final Widget child;
  final Duration duration;
  final Duration startAfterDuration;
  const QudsAutoAnimatedSize(
      {Key? key,
      required this.child,
      this.startAfterDuration = const Duration(milliseconds: 50),
      this.duration = const Duration(milliseconds: 500)})
      : super(key: key);
  @override
  State<StatefulWidget> createState() => _QudsAutoAnimatedSizeSize();
}

class _QudsAutoAnimatedSizeSize extends State<QudsAutoAnimatedSize>
    with SingleTickerProviderStateMixin {
  bool showChild = false;

  @override
  void initState() {
    super.initState();
    Timer(widget.startAfterDuration, () {
      showChild = true;
      if (mounted) setState(() {});
    });
  }

  @override
  Widget build(BuildContext context) {
    return AnimatedSize(
        child: showChild
            ? widget.child
            : Container(
                width: 1,
                height: 1,
              ),
        curve: Curves.fastLinearToSlowEaseIn,
        duration: widget.duration,
        vsync: this);
  }
}
